package game.monstersandwizards;

public class Monster extends Person {

  /**
   * Constructs a monster.
   * @param name monster's name
   * @param lifePoints number of hit points the monster has
   */
  public Monster(String name, int lifePoints){
    super(name, lifePoints);
  }

  @Override
  public void attack(Victim v) {
    if (!isDead()){
      this.addLife(-v.beingHit(this.getLife()/2));
    }
  }

  @Override
  public int beingHit(int hit) {
    this.addLife(-hit);
    if (this.getLife()<0){
      this.addLife(-this.getLife());
    }
    return (this.getLife()/2);
  }

  @Override
  public int beingBewitched(int hit) {
    this.addLife(-hit);
    if (this.getLife()<0){
      this.addLife(-this.getLife());
    }
    return (this.getLife()/10);
  }

}
