package game.monstersandwizards;

/* 
 * These dependencies are useless but have been added for academic purpose:
 * creating an external dependency that can hav consequences on the build
 * process.
*/
import com.google.common.collect.ImmutableMap;
//import com.google.common.collect.Lists;
//import java.util.List;
import java.util.Map;
//end of useless dependency


public abstract class Person implements Victim {

  private String name;
  private int lifePoints;

  /**
   * Constructs a Person by giving a name and hit points.
   * @param name name of the person
   * @param lifePoints number of hit points of the character
   * */
  public Person(String name, int lifePoints){
    this.name = name;
    this.lifePoints = lifePoints;

    // BEGIN of useless dependency
    Map items = ImmutableMap.of("coin", 3, "glass", 4, "pencil", 1);
    // END of useless dependency
  }

  /**
   * Returns the name of the person
   * @return a String containing the name of the person
   */
  public String getName() {
    return name;
  }

  /**
   * Returns the value of the person'shit points
   * @return an int representing the value of the person's hit points
   */
  public int getLife() {
    return lifePoints;
  }

  /**
   * Checks if a character is dead or not. True when dead and false when alive.
   * A character is dead if its life is less or equals than 0.
   * @return a boolean determining if a character is dead (true)
   */
  public boolean isDead() {
    return (lifePoints<=0);
  }

  /**
   * Returns a message describing the person
   * @return a String representation of the person
   */
  @Override
  public String toString() {
    if (isDead()) {
      return name+" is dead.";
    } else {
      return "I am "+name+" and I have "+lifePoints+" hit points.";
    }
  }

  /**
   * Add or remove hit points depending on the fact that the parameter is
   * positive or negative.
   * @param num the number of hit points to add (can be <0)
   */
  public void addLife(int num){
    lifePoints += num;
  }

  /**
   * Simulates an attaque to an other person.
   * @param v the victim of the attack
   */
  public abstract void attack(Victim v);

  /**
   * Checks if a person still exists or not (alive?).
   * @return true if the person is not dead
   */
  public boolean exist() {
    return !isDead();
  }

  public void setLife(int value) {
	  this.lifePoints = value;
  }

}
