package game.monstersandwizards;

public class Warlock extends Wizard implements SuperPower {


    /**
     * Creates a Warlock. His Power is randomly chosen between 0 and extra/2.
     * @param name Warlock's name
     * @param lifePoints warlock's hit points
     */
    public Warlock(String name, int lifePoints){
        super(name, lifePoints);
    }

    @Override
    public double getPower(){
        return super.getPower()*SuperPower.extra;
    }

    /**
     * Returns the spell intensity
     * @return the intensity of the spell
     */
    public double spell() {
        return Math.random()*getPower();
    }

    @Override
    public int beingBewitched(int hit){
        return (int) (hit * spell());
    }
    
}
