package game.monstersandwizards;

public class Wizard extends Person {

  private double power;

  /**
   * Constructs a wizard.
   * @param name wizard's name
   * @param lifePoints number of the wizard's hit points
   * @param power wizard's power
   */
  public Wizard(String name, int lifePoints){
    super(name, lifePoints);
    this.power = Math.random()*0.5;
  }

  @Override
  public void attack(Victim p) {
    if (!isDead()){
      if ((p instanceof Wizard)||(p instanceof Warlock)){
        this.addLife(-10);
        this.addLife(p.beingBewitched((int) (this.getLife()*this.power)));
      } else{
        this.addLife(p.beingBewitched((int) (this.getLife()*this.power)));
      }
    }
  }

  /**
   * Returns the wizard's power.
   * @return the value of the power
   */
  public double getPower(){
    return power;
  }


  @Override
  public int beingHit(int hit) {
    this.addLife(-hit);
    if (this.getLife()<0){
      this.addLife(-this.getLife());
    }
    return (int) (this.getLife()*this.power);
  }

  @Override
  public int beingBewitched(int hit) {
    return 0;
  }
}
